{*************************************
  2003.03.10 port on protected mode
  go32v2/FreePascal 1.0.6
*************************************}
{2002.01.20}
{1999.09.09}
Unit plDrv;

Interface

Const

{ Extended key codes }

  kbNoKey     = $0000;  kbEsc       = $011B;  kbBack      = $0E08;
  kbTab       = $0F09;  kbEnter     = $1C0D;  kbDel       = $53E0;
  kbHome      = $47E0;  kbPgDn      = $51E0;  kbPgUp      = $49E0;
  kbRight     = $4DE0;  kbDown      = $50E0;  kbUp        = $48E0;
  kbLeft      = $4BE0;  kbEnd       = $4FE0;  kbIns       = $52E0;
  kbMenu      = $0B8E0;

  kbGrMinus   = $4A2D;  kbGrPlus    = $4E2B;  kbGrDel     = $5300;
  kbGrHome    = $4700;  kbGrPgDn    = $5100;  kbGrPgUp    = $4900;
  kbGrRight   = $4D00;  kbGrDown    = $5000;  kbGrUp      = $4800;
  kbGrLeft    = $4B00;  kbGrEnd     = $4F00;  kbGrIns     = $5200;
  kbGrStar    = $372A;  kbGrSlash   = $0E02F; kbGrEnter   = $0E00D;
  kbGrCenter  = $4C00;

  kbF1        = $3B00;  kbF2        = $3C00;  kbF3        = $3D00;
  kbF4        = $3E00;  kbF5        = $3F00;  kbF6        = $4000;
  kbF7        = $4100;  kbF8        = $4200;  kbF9        = $4300;
  kbF10       = $4400;  kbF11       = $8500;  kbF12       = $8600;

  kbSpace     = $3920;

{ With Alt }

  kbAltMinus  = $8200;  kbAltPlus   = $8300;  kbAltSpace  = $0200;
  kbAltTab    = $0A500; kbAltEsc    = $0100;  kbAltBack   = $0E00;
  kbAltEnter  = $1C00;  kbAltTilda  = $2900;  kbAltIns    = $0A200;
  kbAltDel    = $0A300; kbAltHome   = $9700;  kbAltEnd    = $9F00;
  kbAltPgUp   = $9900;  kbAltPgDn   = $0A100; kbAltMenu   = $0DCE0;

  kbAltLBrack = $1A00; { [ }  kbAltRBrack = $1B00; { ] }
  kbAltColon  = $2700; { : }  kbAltQuote  = $2800; { " }
  kbAltComma  = $3300; { , }  kbAltSpot   = $3400; { . }
  kbAltQuest  = $3500; { ? }  kbAltSlash  = $2B00;
  kbAltGrSlash = $0A400;      kbAltGrStar = $3700;
  kbAltGrMinus = $4A00;       kbAltGrPlus = $4E00;
  kbAltUp     = $9800;        kbAltDown   = $0A000;
  kbAltLeft   = $9B00;        kbAltRight  = $9D00;
  kbAltGrEnter = $0A600;

  kbAltA      = $1E00;  kbAltB      = $3000;  kbAltC      = $2E00;
  kbAltD      = $2000;  kbAltE      = $1200;  kbAltF      = $2100;
  kbAltG      = $2200;  kbAltH      = $2300;  kbAltI      = $1700;
  kbAltJ      = $2400;  kbAltK      = $2500;  kbAltL      = $2600;
  kbAltM      = $3200;  kbAltN      = $3100;  kbAltO      = $1800;
  kbAltP      = $1900;  kbAltQ      = $1000;  kbAltR      = $1300;
  kbAltS      = $1F00;  kbAltT      = $1400;  kbAltU      = $1600;
  kbAltV      = $2F00;  kbAltW      = $1100;  kbAltX      = $2D00;
  kbAltY      = $1500;  kbAltZ      = $2C00;

  kbAlt1      = $7800;  kbAlt2      = $7900;  kbAlt3      = $7A00;
  kbAlt4      = $7B00;  kbAlt5      = $7C00;  kbAlt6      = $7D00;
  kbAlt7      = $7E00;  kbAlt8      = $7F00;  kbAlt9      = $8000;
  kbAlt0      = $8100;

  kbAltF1     = $6800;  kbAltF2     = $6900;  kbAltF3     = $6A00;
  kbAltF4     = $6B00;  kbAltF5     = $6C00;  kbAltF6     = $6D00;
  kbAltF7     = $6E00;  kbAltF8     = $6F00;  kbAltF9     = $7000;
  kbAltF10    = $7100;  kbAltF11    = $8B00;  kbAltF12    = $8C00;

{ With Ctrl }

  kbCtrlEsc   = $011B;  kbCtrlTab   = $9400;  kbCtrlIns   = $92E0;{kbCtrlIns   = $04E0;}
  kbCtrlDel   = $06E0;  kbCtrlEnter = $1C0A;  kbCtrlBack  = $0E7F;
  kbCtrlHome  = $77E0;  kbCtrlEnd   = $75E0;  kbCtrlPgUp  = $84E0;
  kbCtrlPgDn  = $76E0;  kbCtrlLeft  = $73E0;  kbCtrlRight = $74E0;
  kbCtrlPrtSc = $72E0;  kbCtrlUp    = $8DE0;  kbCtrlDown  = $91E0;
  kbCtrlMenu  = $0D0E0; kbCtrlSlash = $2B1C;

  kbCtrlA     = $1E01;  kbCtrlB     = $3002;  kbCtrlC     = $2E03;
  kbCtrlD     = $2004;  kbCtrlE     = $1205;  kbCtrlF     = $2106;
  kbCtrlG     = $2207;  kbCtrlH     = $2308;  kbCtrlI     = $1709;
  kbCtrlJ     = $240A;  kbCtrlK     = $250B;  kbCtrlL     = $260C;
  kbCtrlM     = $320D;  kbCtrlN     = $310E;  kbCtrlO     = $180F;
  kbCtrlP     = $1910;  kbCtrlQ     = $1011;  kbCtrlR     = $1312;
  kbCtrlS     = $1F13;  kbCtrlT     = $1414;  kbCtrlU     = $1615;
  kbCtrlV     = $2F16;  kbCtrlW     = $1117;  kbCtrlX     = $2D18;
  kbCtrlY     = $1519;  kbCtrlZ     = $2C1A;

  kbCtrl2     = $300;   kbCtrl6     = $71E;   kbCtrlMinus = $0C1F;

  kbCtrlGrSlash = $9500; kbCtrlGrStar  = $9400;  kbCtrlGrMinus = $8E00;
  kbCtrlGrPlus  = $9000; kbCtrlGrEnter = $0E00A; kbCtrlGrIns   = $9200;
  kbCtrlGrDel   = $9300; kbCtrlGrHome  = $7700;  kbCtrlGrEnd   = $7500;
  kbCtrlGrPgUp  = $8400; kbCtrlGrPgDn  = $7600;  kbCtrlGrLeft  = $7300;
  kbCtrlGrRight = $7400; kbCtrlGrUp    = $8D00;  kbCtrlGrDown  = $9100;
  kbCtrlGrCenter = $8F00;

  kbCtrlF1    = $5E00;  kbCtrlF2    = $5F00;  kbCtrlF3    = $6000;
  kbCtrlF4    = $6100;  kbCtrlF5    = $6200;  kbCtrlF6    = $6300;
  kbCtrlF7    = $6400;  kbCtrlF8    = $6500;  kbCtrlF9    = $6600;
  kbCtrlF10   = $6700;  kbCtrlF11   = $8900;  kbCtrlF12   = $8A00;

{ With Shift }

  kbShiftIns  = $0500;  kbShiftDel  = $0700;  kbShiftTab  = $0F00;

  kbShiftF1   = $5400;  kbShiftF3   = $5600;  kbShiftF2   = $5500;
  kbShiftF4   = $5700;  kbShiftF6   = $5900;  kbShiftF5   = $5800;
  kbShiftF7   = $5A00;  kbShiftF9   = $5C00;  kbShiftF8   = $5B00;
  kbShiftF10  = $5D00;  kbShiftF11  = $8700;  kbShiftF12  = $8800;

  kbShiftMenu = $0C4E0;

{ Keyboard state and shift masks }

  kbRightShift  = $0001;     kbLeftCtrl    = $0100;
  kbLeftShift   = $0002;     kbLeftAlt     = $0200;
  kbCtrl        = $0004;     kbRightCtrl   = $0400;
  kbAlt         = $0008;     kbRightAlt    = $0800;
  kbScrollState = $0010;     kbScrollPress = $1000;
  kbNumState    = $0020;     kbNumPress    = $2000;
  kbCapsState   = $0040;     kbCapsPress   = $4000;
  kbInsState    = $0080;     kbSysReqPress = $8000;

{ Function }

Function GetKey_:Word;
Function GetShiftKey:Word;
Function KeyPressed:Boolean;

Implementation
var GK1,GK2,GSK,KP1:byte;

Function GetKey_:Word;assembler;
asm
        mov  ah,GK1
        int  16h
        mov  eax,0
        je   @@GK3
        mov  ah,GK2
        int  16h
@@GK3:
end;
Function GetShiftKey:Word;assembler;
asm
        mov  ah,GSK
        int  16h
end;
Function KeyPressed:Boolean;assembler;
asm
        mov  ah,KP1
        int  16h
        mov  al,0
        jz   @@KP2
        inc  al
@@KP2:
end;
begin
     GK1:=$11;
     GK2:=$10;
     GSK:=$12;
     KP1:=$11;
{     GK1:=1;
     GK2:=0;
     GSK:=2;
     KP1:=1;
     asm
        mov  ah,9
        int  16h
        shr  al,1
        and  al,10h
        or   GK1,al
        or   GK2,al
        or   GSK,al
        or   KP1,al
     end;}
end.