{*************************************
  2003.03.10 port on protected mode
  go32v2/FreePascal 1.0.6
*************************************}
{1999.07.28}
Unit plTree; 

Interface

Procedure TreeInsRecord(Prev,Next:Pointer;b:Boolean);
{ ⠢   ᯨ᮪
  ᯮ  ⨯ (PointToPrev,PointToNext:Pointer;...)

  Prev - 㪠⥫  ᭮ 
  Next - 㪠⥫  塞 
  b: True  -  ᫥ ᭮ 
     False -  । ᭮ ⮬
}

Function  TreeDelRecord(Current:Pointer;b:Boolean):Pointer;
{    ᯨ᪠
  ᯮ  ⨯ (PointToPrev,PointToNext:Pointer;...)

  Current - 㪠⥫  㤠塞 
  b: True  - ᫥ 㤠 ⥪騬 ᤥ ᫥騩
     False - ᫥ 㤠 ⥪騬 ᤥ ।騩
}

Procedure TreeDelAll(var Current:Pointer);
{     ᯨ᪠
  ᯮ  ⨯ (PointToPrev,PointToNext:Pointer;...)

  Current - 㪠⥫    㤠塞 
}
(*
Function TreePrevRecord(Current:Pointer):Pointer;
{ 宦 ।饣 
  ᯮ  ⨯ (PointToPrev,PointToNext:Pointer;...)
  Current - 㪠⥫  ⥪騩 
}
Function TreeNextRecord(Current:Pointer):Pointer;
{ 宦 ᫥饣 
  ᯮ  ⨯ (PointToPrev,PointToNext:Pointer;...)
  Current - 㪠⥫  ⥪騩 
}*)
Function TreeFirstRecord(Current:Pointer):Pointer;
{ 宦 ࢮ 
  ᯮ  ⨯ (PointToPrev,PointToNext:Pointer;...)
  Current - 㪠⥫  ⥪騩 
}
Function TreeLastRecord(Current:Pointer):Pointer;
{ 宦 ᫥ 
  ᯮ  ⨯ (PointToPrev,PointToNext:Pointer;...)
  Current - 㪠⥫  ⥪騩 
}

Implementation

Uses plMem;

Type
    PTreeRecord = ^TTreeRecord;
    TTreeRecord = Record
       Prev           :PTreeRecord;
       Next           :PTreeRecord;
    End;

Procedure TreeInsRecord(Prev,Next:Pointer;b:Boolean);
Begin
//     writeln('TreeInsRecord');
     If (b) Then Begin
      If Next<>Nil Then Begin
        PTreeRecord(Next)^.Prev:=Prev;
        If Prev<>Nil Then Begin
           PTreeRecord(Next)^.Next:=PTreeRecord(Prev)^.Next;
           If PTreeRecord(Prev)^.Next<>Nil Then
              PTreeRecord(Prev)^.Next^.Prev:=Next;
           PTreeRecord(Prev)^.Next:=Next;
        End Else PTreeRecord(Next)^.Next:=Nil;
      End
     End Else Begin
      If Next<>Nil Then Begin
        PTreeRecord(Next)^.Next:=Prev;
        If Prev<>Nil Then Begin
           PTreeRecord(Next)^.Prev:=PTreeRecord(Prev)^.Prev;
           If PTreeRecord(Prev)^.Prev<>Nil Then
              PTreeRecord(Prev)^.Prev^.Next:=Next;
           PTreeRecord(Prev)^.Prev:=Next;
        End Else PTreeRecord(Next)^.Prev:=Nil;
      End
     End;
End;
Function TreeDelRecord(Current:Pointer;b:Boolean):Pointer;
Begin
//     writeln('TreeDelRecord');
     If Current<>Nil Then Begin
        If PTreeRecord(Current)^.Next<>Nil Then
           PTreeRecord(Current)^.Next^.Prev:=PTreeRecord(Current)^.Prev;
        If PTreeRecord(Current)^.Prev<>Nil Then
           PTreeRecord(Current)^.Prev^.Next:=PTreeRecord(Current)^.Next;
        If ((b)And(PTreeRecord(Current)^.Next<>Nil))Or
           (Not(b))And(PTreeRecord(Current)^.Prev=Nil) Then
           TreeDelRecord:=PTreeRecord(Current)^.Next Else
           TreeDelRecord:=PTreeRecord(Current)^.Prev;
        MemFree(Current);
     End Else TreeDelRecord:=Nil;
End;
Procedure TreeDelAll(var Current:Pointer);
Begin
//     writeln('TreeDelAll');
//     write(dword(Current));
//     writeln('TreeDelAll2');
     If Current<>Nil Then Begin
        While PTreeRecord(Current)^.Next<>Nil Do begin
              PTreeRecord(Current):=PTreeRecord(Current)^.Next;
//              write('->',dword(Current));
        end;
        While PTreeRecord(Current)^.Prev<>Nil Do Begin
           Current:=PTreeRecord(Current)^.Prev;
           MemFree(PTreeRecord(Current)^.Next);
//           write('<-',dword(Current));
        End;
        MemFree(Current);
        Current:=Nil;
//        write('<-',dword(Current));
     End;
End;
{
Function TreePrevRecord(Current:Pointer):Pointer;
Begin
     TreePrevRecord:=Current;
     If PTreeRecord(Current)<>Nil Then
        If PTreeRecord(Current)^.Prev<>Nil Then
           TreePrevRecord:=PTreeRecord(Current)^.Prev;
End;

Function TreeNextRecord(Current:Pointer):Pointer;
Begin
     TreeNextRecord:=Current;
     If PTreeRecord(Current)<>Nil Then
        If PTreeRecord(Current)^.Next<>Nil Then
           TreeNextRecord:=PTreeRecord(Current)^.Next;
End;
}
Function TreeFirstRecord(Current:Pointer):Pointer;
Begin
//     writeln('TreeFirstRecord');
     If PTreeRecord(Current)<>Nil Then
        While PTreeRecord(Current)^.Prev<>Nil Do
           Current:=PTreeRecord(Current)^.Prev;
     TreeFirstRecord:=Current;
End;

Function TreeLastRecord(Current:Pointer):Pointer;
Begin
//     writeln('TreeLastRecord');
     If PTreeRecord(Current)<>Nil Then
        While PTreeRecord(Current)^.Next<>Nil Do
           Current:=PTreeRecord(Current)^.Next;
     TreeLastRecord:=Current;
End;

End.
