Unit plPlug;

Interface
Uses plType,plMem,plWin,plFile,SysUtils,plBrow,plScr,plTree,plDrv;

Type PPlugParam = ^TPlugParam;
     TPlugParam = Record
        ParamSize:Word;PParam:Pointer;
        ValueSize:Word;PValue:Pointer;
        PStrToOem,
        POemToStr,
        POemLow,
        POemUp,
        PStrToUnicode,
        PUnicodeToStr,
        PMessageBox,
        PWarning,
        PScrSave,
        PScrRest,
        PGetKey,
        PGetShiftKey,
        PKeyPressed:Pointer;
     End;

     PPlugBrow = ^TPlugBrow;
     TPlugBrow = Record
             Prev,Next:Pointer;
             PName:^String;
             Color,c1,c2:Byte;
             PlugName:String[12];
             Name:Byte;
     End;


Function PlugSelect(s:String):String;
Function PlugLoad(s:String;Param:PPlugParam):Boolean;

Implementation
Function PlugSelect(s:String):String;
Const LenX = 71;
Var F:Text;
    q1,q:PPlugBrow; {TBR1}
    t:TBR2;
    i,x1,x2,y1,y2:Byte;
    key:Word;
    ss:Pointer;
    s1,s2:String;
Begin
     PlugSelect:='';
     s2:=ParamStr(0);

     While (Byte(s2[0])>0)And(s2[Byte(s2[0])]<>'\') Do Dec(Byte(s2[0]));

     s2:=s2+'PLUGINS\';
     s:=s2+s;

     Assign(F,s);
     {$I-}
     Reset(F);
     {$I+}
     if IOResult=0 Then Begin
      x2:=LenX+4;
      x1:=(MaxColumn-x2)shr 1;x2:=x1+x2-1;
      y2:=11;
      y1:=(MaxRow-y2-1)shr 1;y2:=y1+y2-1;
      ss:=Window(x1,y1,x2,y2,'ͻȺ',Black,Cyan,True);
      if ss<>Nil Then Begin
       ColorTextSet(0);
       ColorBackSet(3);
       OutStr(x1+18,y1+1,'Registry Viewer Plugin Launcher 1.3');
       OutStr(x1+22,y1+2,'General Paul Lee Corruption');
       LineH(x1,y1+3,x2,'','','');
       OutStr(x1+1,y2,'[      Select     Quit]');
       ColorTextSet(15);
       ColorBackSet(3);
       OutStr(x1+2,y2,'Enter');
       OutStr(x1+15,y2,'Esc');
       q:=Nil;
       While Not(Eof(F)) Do Begin
        ReadLn(F,s);
        For i:=1 To Byte(s[0]) Do If s[i]<' ' Then s[i]:=' ';
        i:=1;
        While (i<Byte(s[0]))And(s[i]=' ') Do Inc(i);
        s:=Copy(s,i,Byte(s[0])-i+1);
        if s[1]=';' Then Continue;
        i:=Byte(s[0]);
        While (i>0)And(s[i]=' ') Do Dec(i);
        Byte(s[0]):=i;
        If i<>0 Then Begin
         i:=Pos(' ',s);
         if i=0 Then s1:=s Else Begin
          s1:=Copy(s,i+1,Byte(s[0])-i);
          Byte(s[0]):=i-1;
          i:=1;
          While (i<Byte(s1[0]))And(s1[i]=' ') Do Inc(i);
          s1:=Copy(s1,i,Byte(s1[0])-i+1);
          if s1='' Then s1:=s;
         End;
         {s:=' '+s;}
         if Byte(s[0])>71 Then Byte(s[0]):=71;
         q1:=q;
         q:=BrowNewRecord(s1,$0FF,q1,SizeOf(TPlugBrow),True,$30,7);
         if q<>Nil then begin
          q^.PlugName:=s;
         end else begin
          q:=q1;
          Break;
         end;
        End;
       End;
       While q^.Prev<>Nil Do q:=q^.Prev;
       t:=BrowCreate(q,x1+1,y1+1+3,x1+1,y1+1+3,x2-1,y2-1,0,5,false,2);
       If t<>Nil Then Begin
        t^.Activ:=True;
        While (key<>kbEsc)And(key<>kbEnter)And(key<>kbGrEnter) Do Begin
         key:=Brow(t,kbNoKey);
        End;
        q:=t^.Tec;
        If key<>kbEsc Then Begin
         PlugSelect:=s2+q^.PLugName;
        End;
        BrowDelete(t);
       End;
       TreeDelAll(q);
       ScrRest(ss);
      End;
      Close(F);
     End;
End;
Function PlugLoad(s:String;Param:PPlugParam):Boolean;
Var PlugMem,p:PByte;
    F,fs:longint;
Begin
     PlugLoad:=False;
     if s='' then exit;
     F:=FileOpen(s,fmOpenRead);
     if F<>-1 Then Begin
      fs:=FileSize(F);
      PlugMem:=MemAlloc(fs+256+4);
      if PlugMem<>Nil Then Begin
       //MemSet(PlugMem,fs+256+4,0);
       p:=PlugMem;
       Inc(p,256);
       if FileRead(F,p^,fs)<>-1 Then Begin
          Inc(p,fs);
          MemCopy(@Param,p,4);
          //Inc(p,4);
          //MemCopy(PlugMem,p,4);
          p:=PlugMem;
          Inc(p,256);
          asm
           call [p]
           mov  result,eax
          end;
       End;
       MemFree(PlugMem);
      End;
      FileClose(F);
     End;
End;
End.
