Program RegVAll;

Uses plType, RegV9x, RegVNT, plFile, SysUtils, plStr, plOem, plUni, DpmiExcp, plFileBr;

Const HeaderNT = $66676572; {'regf'}
      Header9x = $47455243; {'CREG'}


Var F:longint;
    FMode:Byte;
    RegType:LongInt;
    i:integer;
    fname:string;
    OldAttr:longint;
//    ExpCnt:LongInt;
Begin
     djgpp_set_ctrl_c(false);
     fname:='';
     if ParamCount=0 then fname:=getFileBr;
     if ParamCount=1 then fname:=ParamStr(1);
     if(fname='')then begin
        Writeln('Registry Viewer 4.2 for Win9x/Me/NT/2K/XP by General Paul Lee (c) 1999-2005.');
        Writeln;
        Writeln('This program is for viewing Win9x/Me/NT/2K/XP registry files in DOS mode,');
        Writeln('simple editing and exporting them to text file.');
        Writeln;
        Writeln('Usage: RegView <regfile>');
        Writeln;
        Exit;
     end;
     FMode:=fmOpenReadWrite;
     OldAttr:=FileGetAttr(fname+#0);
     F:=FileOpen(fname,FMode);
     If F=-1 Then If FileSetAttr(fname+#0,0)<>-1 Then
           F:=FileOpen(fname,FMode);
     If F=-1 Then Begin
        FMode:=fmOpenRead;
        F:=FileOpen(fname,FMode);
     End;
     If F=-1 Then Begin
        Writeln('File open error.');
        Exit;
     End;
//     ExpCnt:=0;
     FileRead(F,RegType,4);
     If RegType=HeaderNT Then RegVNTRun(F,FMode,fname) Else
     If RegType=Header9x Then RegV9xRun(F,FMode,fname) Else
     Writeln('File is corrupt or not in Win9x/Me/NT/2K/XP registry format. (0'+HexStr(RegType,4)+'h)');
     FileClose(F);
     FileSetAttr(fname+#0,OldAttr);
End.
