{==}
Const {Header1   }h_regf:LongInt = $66676572; {'regf'}
      {Header2   }h_hbin:LongInt = $6E696268; {'hbin'}
      {SubHeader1}h_lf:word = $666C;     {'lf'}
      {SubHeader1}h_lh:word = $686C;     {'lh'}
      {SubHeader2}h_nk:word = $6B6E;     {'nk'}
      {SubHeader3}h_sk:word = $6B73;     {'sk'}
      {SubHeader4}h_vk:word = $6B76;     {'vk'}
      {SubHeader5}h_ri:word = $6972;     {'ri'}
      {SubHeader6}h_li:word = $696C;     {'li'}

      MaxLen = 71;
      MinBuffSize = $1000;
      MaxBuffSize = $F000;

      cMinHbinSize  = $1000;
      cMaxBlockSize = cMinHbinSize-$20;
      cMaxLF = $1FB;
      cMaxLI = $3F5;

      Space = '                                                        ';

      cRegNT = 3; cReg2K = 4; cRegXP = 5;

Type NTHeader = Record
            Head:Longint;
            H01,H02,H03,H04,H05,RegVer,
            H07,H08,Offs,DataSize,H11:Longint;
            Garbage:array[1..$80-13] of LongInt;
            CheckSum:LongInt;
     End;

     PNThbin = ^NThbin;
     NThbin = Record
            Head:LongInt;
            Offs:LongInt;
            Size:LongInt;
            w1,w2,w3,w4:word;
            L1,L2,L3:LongInt;
     End;

     PNTSubHeader=^NTSubHeader;
     NTSubHeader = Record
            NodeSize:LongInt;
            NodeType:word;
     End;

     PNTNode=^NTNode;
     NTNode = Record
            NodeSize:LongInt;
            NodeType:word;
            flag:word;
            TimeStamp:Double;
            L1:LongInt;
            Parent:LongInt;
            ChildCount:LongInt;
            L2:LongInt;
            PChildIndex:LongInt;
            L3:LongInt;
            ParCount:LongInt;
            PParIndex:LongInt;
            PSec:LongInt;
            PClass:LongInt;
            L4,L5,L6,L7,L8:LongInt;
            NodeNameSize:word;
            ClassNameSize:word;
            NodeName:Byte;
     End;

     PNTPar=^NTPar;
     NTPar = Record
            NodeSize:LongInt;
            NodeType:word;
            ParNameSize:word;
            ValueSize:LongInt;
            PValue:LongInt;
            ParType:LongInt;
            w1,w2:word;
            ParName:Byte;
     End;

     PNTSec=^NTSec;
     NTSec = Record
            NodeSize:LongInt;
            NodeType,w1:word;
            PrevSK,NextSK,CountNK,SDSize:LongInt;
     End;

     PSecDescr = ^Security_Descriptor;
     Security_Descriptor = Record
            Rev,Sbz:Byte;
            Control:Word;
            Owner,Group,Sacl,Dacl:LongInt;
     End;

     PACL = ^TACL;
     TACL = Record
            Rev,Sbz1:Byte;
            ACLSize,ACECount,Sbz2:Word;
     End;

     PACE = ^TACE;
     TACE = Record
            ACEType,ACEFlag:Byte;
            ACESize:Word;
            AccessMask,SID:LongInt;
     End;

     PNode = ^TNode;
     TNode = Record
             Prev,Next:Pointer;
             PName:^String;
             Color,c1,c2:Byte;
             PSelf:LongInt;  { ᪠ 㦭   室 }
             Parent:LongInt;
             ChildCount:LongInt;
             PChildIndex:LongInt;
             ParCount:LongInt;
             PParIndex:LongInt;
             Name:Byte;
     End;

     PPar  = ^TPar;
     TPar  = Record
             Prev,Next:Pointer;
             PName:^String;
             Color,c1,c2:Byte;
             ValType:LongInt;
             Value:LongInt;
             ValSize:LongInt;
             Self:LongInt;
             Name:Byte;
     End;

     PVal  = TBR1;{^TVal;
     TVal  = Record
             Prev,Next:Pointer;
             PName:^String;
             Color,c1,c2:Byte;
             Name:Byte;
     End;}

     PPath = ^TPath;
     TPath = Record
             Prev,Next:Pointer;
             PName:^String;
             Color,c1,c2:Byte;
             Name:Byte;
     End;

     InfoNT = Record
              Size,MaxSize,Count,Checksum:LongInt;
     End;

     PExpPath = ^ExpPath;
     ExpPath = Record
         Next,Prev:PExpPath;
//         c,c1,c2:byte;
         Name:Byte;
     End;
//     PString = ^String;

