{*************************************
  2003.03.10 port on protected mode
  go32v2/FreePascal 1.0.6
*************************************}
{2001.04.08}
Unit plEdit;

Interface

Uses plMem,plDrv,plScr,plBrow,plTime;

{Const
       ColorMax = 6;

       ColorAr:Array[0..ColorMax,1..4] Of Byte = (
       (Cyan,Blue,White,White),
       (Cyan,Blue,Blue,LightCyan),
       (Cyan,Black,Red,Lightred),
       (Cyan,Blue,Magenta,LightMagenta),
       (Cyan,Blue,LightGreen,LightGreen),
       (Cyan,Cyan,Black,Black),
       (Black,Cyan,LightGray,Black));
}

Type

PStrEdit = ^TStrEdit;
TStrEdit = Record
         Str,               { ப}
         Str1,              {ப,   ࠭}
         Filter:String;     {䨫   ᨬ,
                             ᫨ ⮩ -   ,
                             ᫨ ,  ⮫쪮 㪠}
         EdtMode:byte;      {० ⠢ 뫮:(true)/(false)}
                            { 0: 0 - , 1 - ⠢}
                            { 1: 0 -   ०, 1 - }
                            { 2: 0 -  㤠 ᨬ, 1 - }
         Refresh:boolean;   {室 }
         x1,y1,x2,y2,       {न }
         size,              {ࠧ ப}
         z,                 {ᨬ }
         x,                 { }
         tab,               {ᤢ ப}
         Col:Byte;          {梥⮢ }

End;

Function StrEditCreate(x1_,y1_,x2_,y2_,size_,z_:byte;s_,sf:String;ins_:byte;Col_:Byte):PStrEdit;
{    ।஢
   न⠬ x1_,y1_,x2
  ᨬ ࠧ஬ 室 ப size_
  ᨬ  z_
  砫쭮 ப s_
  梥⮢  Col_
  頥 㪠⥫  ᮧ  
}

Function StrEditRun(PSE:PStrEdit;Activ:boolean):word;
{ ⢫  ।஢ ப
   㪠   ।஢
  頥  ࠡ⠭ 
  Activ = true  - ⨢஢ ।
  Activ = false - ⮫쪮 ⮡ࠧ

  १ࢨ஢ :
  㪢, , 
  LeftArrow, RightArrow, Home, End, Backspace, Delete, Insert
         // Shift- LeftArrow, RightArrow, Home, End
  ᯮ //  Ctrl- LeftArrow, RightArrow, Backspace
}

Procedure StrEditDel(PSE:PStrEdit);
{    ।஢
}

Implementation

Function StrEditCreate(x1_,y1_,x2_,y2_,size_,z_:byte;s_,sf:String;ins_:byte;Col_:Byte):PStrEdit;
Var PSE:PStrEdit;
Begin
     PSE:=MemAlloc(SizeOf(TStrEdit));
     If PSE<>Nil Then Begin
       With PSE^ do Begin
          Str:=s_;
          Filter:=sf;
          x1:=x1_;y1:=y1_;x2:=x2_;y2:=y2_;z:=z_;size:=size_;x:=0;tab:=0;
          Str1[0]:=Char(x2-x1+1);
          MemSet(@Str1[1],Byte(Str1[0]),z_);
          Refresh:=True;
          EdtMode:=ins_;
          If Col_>ColorMax Then Col_:=2;
          Col:=Col_;
       End;
     End;
     StrEditCreate:=PSE;
End;

Procedure StrEditDel(PSE:PStrEdit);
Begin
     MemFree(PSE);
End;

Function StrEditRun(PSE:PStrEdit;Activ:boolean):word;
Var key:word;
    Flag:boolean;
Begin
     key:=kbNoKey;
     If PSE<>Nil Then With PSE^ do Begin
        CursSet(x1+x-1,y1-1);
        If Activ Then Begin If((EdtMode And 1)=1) Then CursOn Else CursOn1
        End Else CursOff;
        Repeat
          If Refresh Then Begin
            If Byte(Str[0])>(Byte(Str1[0])+tab) Then
             Str1:=Copy(Str,(tab+1),Byte(Str1[0]))
            Else Begin
             MemSet(@Str1[1],Byte(Str1[0]),z);
             Str1:=Copy(Str,(tab+1),Byte(Str[0])-tab);
             Str1[0]:=Char(x2-x1+1);
            End;
            If Activ Then Begin
               ColorBackSet(ColorAr[Col,2]);
               ColorTextSet(ColorAr[Col,4]);
            End Else Begin
               ColorBackSet(ColorAr[Col,1]);
               ColorTextSet(ColorAr[Col,3]);
            End;
            OutStr(x1,y1,Str1);
            CursSet(x1+x-1,y1-1);
          End;
          Flag:=False;
          If Activ Then key:=GetKey_ Else Flag:=True;
          Refresh:=True;
          Case key Of
           kbNoKey: Refresh:=false;
           kbGrLeft,
           kbLeft:  If x>0 Then Dec(x) Else If tab>0 Then Dec(tab);
           kbGrRight,
           kbRight: If (tab+x<Byte(Str[0]))And(tab+x+1<size) Then
                       If x<x2-x1 Then Inc(x) Else Inc(tab);
           kbGrHome,
           kbHome:  Begin
                       x:=0;tab:=0;
                    End;
           kbGrEnd,
           kbEnd:   If tab+x<Byte(Str[0]) Then
                       If Byte(Str[0])-tab<x2-x1 Then Begin
                          x:=Byte(Str[0])-tab;
                          If Byte(Str[0])>=size Then Dec(x);
                       End Else Begin
                          x:=x2-x1;tab:=Byte(Str[0])-x;
                          If Byte(Str[0])>=size Then Dec(tab);
                       End;
           kbGrIns,
           kbIns:   Begin
                       If ((EdtMode And 2)=0) Then Begin
                          If ((EdtMode And 1)=0) Then
                             EdtMode:=(EdtMode Or 1) Else
                             EdtMode:=(EdtMode And -2);
                       End;
                       If ((EdtMode And 1)=1) Then CursOn Else CursOn1;
                    End;
           kbGrDel,
           kbDel:   If (x<(Byte(Str[0])-tab))And((EdtMode And 4)=0) Then
                       Delete(Str,x+tab+1,1);
           kbBack:  If ((x+tab)>0)And((EdtMode And 4)=0) Then Begin
                       Delete(Str,x+tab,1);
                       If x<((x2-x1) shr 1)Then
                          If tab<((x2-x1) shr 1) Then Begin
                             x:=x+tab-1;tab:=0;
                          End Else Begin
                             x:=x+((x2-x1) shr 1)-1;
                             tab:=tab-((x2-x1) shr 1);
                          End
                       Else Dec(x);
                    End;
           Else If (Lo(key)>=32)And(Lo(key)<=255)
                  And((Lo(key)<>224)or(key=224)) Then Begin
                  If (EdtMode And 1 = 0)Or
                     ((EdtMode And 1 = 1)And(Byte(Str[0])<size)) Then
                  Begin { ᨬ}
                   If (Byte(Filter[0])=0)Or(Pos(Char(key),Filter)>0) Then
                   Begin {஢ਫ 䨫}
                    If x=Byte(Str[0])-tab Then Str:=Str+Char(Byte(key))
                    Else If (EdtMode And 1 = 1) Then Insert(Char(Byte(key)),Str,tab+x+1)
                         Else Str[tab+x+1]:=Char(Byte(key));
                    If Tab+x+1<size Then Begin
                       If x<x2-x1 Then Inc(x)
                       Else Inc(tab);
                    End;
                   End Else Begin
                      ColorBackSet(not(ColorAr[Col,1]));
                      ColorTextSet(not(ColorAr[Col,3]));
                      OutStr(x1,y1,Str1);
                      Pause(2);
                      ColorBackSet(ColorAr[Col,1]);
                      ColorTextSet(ColorAr[Col,3]);
                      OutStr(x1,y1,Str1);
                      While KeyPressed do GetKey_;
                   End;
                  End End Else If key<>kbNoKey Then Begin
                      Flag:=True;
                      Refresh:=False;
                  End;
          End; {Case}

        Until (Flag);

     End;
     StrEditRun:=key;
End;

End.