{*************************************
  2003.03.10 port on protected mode
  go32v2/FreePascal 1.0.6
*************************************}
Unit plScr;

Interface

Const   Black        = 0;       Blue         = 1;
        Green        = 2;       Cyan         = 3;
        Red          = 4;       Magenta      = 5;
        Brown        = 6;       LightGray    = 7;
        DarkGray     = 8;       LightBlue    = 9;
        LightGreen   = 10;      LightCyan    = 11;
        LightRed     = 12;      LightMagenta = 13;
        Yellow       = 14;      White        = 15;

Function ScrSave(x1,y1,x2,y2:byte):Pointer;
{----------[     
           [   
}
Procedure ScrRest(var p:Pointer);
{----------[     
}
Procedure Shadow(x1,y1,x2,y2:byte);
{----------[        
}
Function  GetRowCol:Word;
{----------[      ,
           [    -    
}
Procedure LineH(x1,y,x2:byte;b1,b2,b3:Char);
{----------[    ()   -
           [  S[2].     S[1]  S[3]
}
Procedure LineV(y1,x,y2:byte;b1,b2,b3:Char);
{----------[  LineG  
}
Procedure Box(x1,y1,x2,y2:byte;b1,b2,b3,b4,b5,b6,b7,b8:Char);
{----------[   ,  2  
}
Procedure ScrClr(x1,y1,x2,y2:byte);
{----------[    
}
Procedure OutStr(x,y:byte;s:String);
{----------[     
}
Procedure Mark(x1,y,x2:byte);
{----------[     
}
Procedure CursSet(x,y:byte);
{----------[     x,y
}
Procedure CursOff;
{----------[  
}
Procedure CursOn;
{----------[  
}
Procedure CursOn1;
{----------[   ()
}
Procedure ColorTextSet(b:Byte);
{----------[    
}
Procedure ColorBackSet(b:Byte);
{----------[    
}
Function  MaxColumn:byte;
{----------[    
}
Function  MaxRow:byte;
{----------[    
}

Implementation

uses plMem;
type pbyte = ^byte;
const screen:dword = $B8000;

var
   MaxC,MaxR,
   ColorBack,ColorText:byte;

Function  ScrSave(x1,y1,x2,y2:byte):Pointer;
var p:pbyte;
    w:word;
    i,j:byte;
begin
//     writeln('save');
     if x1>MaxC then x1:=MaxC;
     if y1>MaxR then y1:=MaxR;
     if x2<x1 then x2:=x1;
     if y2<y1 then y2:=y1;
{*     writeln('x ',x1);
     writeln('y ',y1);
     writeln('x ',x2);
     writeln('y ',y2);*}
     Result:=MemAlloc((x2-x1+1)*(y2-y1+1)*2+4);
     if Result<>nil then begin
       p:=Result;
       p^:=x1;inc(p);
       p^:=y1;inc(p);
       p^:=x2;inc(p);
       p^:=y2;inc(p);
       for i:=y1 to y2 do begin
        w:=MaxC*2*(i-1);
        for j:=x1 to x2 do begin
            p^:=mem[screen + w + j*2-1];inc(p);
            p^:=mem[screen + w + (j-1)*2];inc(p);
        end;
       end;
     end;
end;

Procedure ScrRest(var p:Pointer);
var x1,y1,x2,y2,i,j:byte;
    w:word;
    q:pbyte;
begin
//     writeln('restore');
     if p<>nil then begin
       q:=p;
       x1:=q^;inc(q);
       y1:=q^;inc(q);
       x2:=q^;inc(q);
       y2:=q^;inc(q);
       for i:=y1 to y2 do begin
        w:=MaxC*2*(i-1);
        for j:=x1 to x2 do begin
            mem[screen + w + j*2-1]:=q^;inc(q);
            mem[screen + w + (j-1)*2]:=q^;inc(q);
        end;
       end;
       MemFree(p);p:=nil;
     end;
end;

Procedure Shadow(x1,y1,x2,y2:byte);
var i:byte;
    w:word;
begin
     if x1>MaxC then x1:=MaxC;
     if y1>MaxR then y1:=MaxR;
     if x2<x1 then x2:=x1;
     if y2<y1 then y2:=y1;
     w:=MaxC*2*y2;
     if y2<MaxR then for i:=x1+2 to x2 do
       mem[screen + w + i*2-1]:=mem[screen + w + i*2-1]and 7
     else dec(y2);
     if x2<MaxC then for i:=y1 to y2 do begin
        w:=MaxC*2*i;
        mem[screen + w + (x2+1)*2-1]:=mem[screen + w + (x2+1)*2-1]and 7;
        if (x2+1)<MaxC then
           mem[screen + w + (x2+2)*2-1]:=mem[screen + w + (x2+2)*2-1]and 7;
     end;
end;

Function  GetRowCol:Word;
begin
     MaxC:=mem[$44A];
     MaxR:=mem[$484]+1;
     Result:=(MaxC shl 8)or MaxR;
end;
Procedure LineH(x1,y,x2:byte;b1,b2,b3:Char);
var i:byte;
    w:word;
begin
     if x1>MaxC then x1:=MaxC;
     if y>MaxR then y:=MaxR;
     if x2<x1 then x2:=x1;
     w:=MaxC*2*(y-1);
     memw[screen + w + (x1-1)*2]:=(((ColorBack shl 4)or ColorText)shl 8)or byte(b1);
     for i:=x1+1 to x2-1 do
      memw[screen + w + (i-1)*2]:=(((ColorBack shl 4)or ColorText)shl 8)or byte(b2);
     memw[screen + w + (x2-1)*2]:=(((ColorBack shl 4)or ColorText)shl 8)or byte(b3);
end;
Procedure LineV(y1,x,y2:byte;b1,b2,b3:Char);
var i:byte;
    w:word;
begin
     if x>MaxC then x:=MaxC;
     if y1>MaxR then y1:=MaxR;
     if y2<y1 then y2:=y1;
     w:=MaxC*2*(y1-1);
     memw[screen + w + (x-1)*2]:=(((ColorBack shl 4)or ColorText)shl 8)or byte(b1);
     for i:=y1+1 to y2-1 do begin
      inc(w,MaxC*2);
      memw[screen + w + (x-1)*2]:=(((ColorBack shl 4)or ColorText)shl 8)or byte(b2);
     end;
     inc(w,MaxC*2);
     memw[screen + w + (x-1)*2]:=(((ColorBack shl 4)or ColorText)shl 8)or byte(b3);
end;
Procedure Box(x1,y1,x2,y2:byte;b1,b2,b3,b4,b5,b6,b7,b8:Char);
begin
     LineH(x1,y1,x2,b1,b2,b3);
     LineH(x1,y2,x2,b7,b6,b5);
     LineV(y1,x1,y2,b1,b8,b7);
     LineV(y1,x2,y2,b3,b4,b5);
end;
Procedure ScrClr(x1,y1,x2,y2:byte);
var i,j:byte;
    w:word;
begin
     if x1>MaxC then x1:=MaxC;
     if y1>MaxR then y1:=MaxR;
     if x2<x1 then x2:=x1;
     if y2<y1 then y2:=y1;
     for i:=y1 to y2 do begin
      w:=MaxC*2*(i-1);
      for j:=x1 to x2 do
       memw[screen + w + (j-1)*2]:=(((ColorBack shl 4)or ColorText)shl 8)or $20;
     end;
end;
Procedure OutStr(x,y:byte;s:String);
var i:byte;
    w:word;
begin
     if x>MaxC then x:=MaxC;
     if y>MaxR then y:=MaxR;
     w:=MaxC*2*(y-1);
     for i:=1 to byte(s[0]) do
      memw[screen + w + (i+x-2)*2]:=(((ColorBack shl 4)or ColorText)shl 8)or byte(s[i]);
end;
Procedure Mark(x1,y,x2:byte);
var i:byte;
    w:word;
begin
     w:=MaxC*2*(y-1);
     for i:=x1 to x2 do
      mem[screen + w + i*2-1]:=(ColorBack shl 4)or ColorText;
end;

Procedure CursSet(x,y:byte);assembler;
asm
   mov  dl,x
   mov  dh,y
   mov  ah,2
   xor  ebx,ebx
   int  10h
end;
Procedure CursOff;assembler;
asm
   mov  ah,1
   mov  ecx,03010h
   xor  ebx,ebx
   int  10h
end;
Procedure CursOn;assembler;
asm
   mov  ah,1
   mov  ecx,707h
   xor  ebx,ebx
   int  10h
end;
Procedure CursOn1;assembler;
asm
   mov  ah,1
   mov  ecx,107h
   xor  ebx,ebx
   int  10h
end;
Procedure ColorTextSet(b:Byte);
begin ColorText:=b; end;
Procedure ColorBackSet(b:Byte);
begin ColorBack:=b; end;
Function  MaxColumn:byte;
begin Result:=MaxC end;
Function  MaxRow:byte;
begin Result:=MaxR end;

Begin
        GetRowCol;
        ColorBack:=0;
        ColorText:=7;
{*        writeln('x ',MaxC);
        writeln('y ',maxR);*}
End.