{*************************************
  2003.03.10 port on protected mode
  go32v2/FreePascal 1.0.6
*************************************}
{2003.11.15}
{2002.07.27}
{2001.05.20}
{2000.08.05}
unit plBrow;

interface

uses plType,plDrv,plScr,plStr,plMem,plTree;

const

{ BackOn,BackOff,TextOn,TextOff1}

       ColorMax = 7;

       ColorAr:array[0..ColorMax,1..4] of byte = (
       (Cyan,Blue,White,White),
       (Cyan,Blue,Blue,LightCyan),
       (Cyan,Black,Red,Lightred),
       (Cyan,Blue,Magenta,LightMagenta),
       (Cyan,Blue,LightGreen,LightGreen),
       (Cyan,Cyan,Black,Black),
       (Black,Cyan,LightGray,Black),
       (Cyan,Black,Black,LightGray));

       ScrollType:array[1..3,1..4] of char = (
                 ('','','',''),
                 ('','','',''),
                 ('','','',''));

type
     TBR1 = ^BrowRec1;
     TBR2 = ^BrowRec2;

     BrowRec1 = record
          Prev,Next:pointer; {TBR1;}
          PName:^string;
          Color,              {for ColorArr}
          Color1,Color2:byte; {if Color=FF}
          Name:byte;
     end;

     BrowRec2 = record
          Tec:pointer; {TBR1;}
          X,Y,MinX,MinY,MaxX,MaxY,Color:byte;
          Refresh,Activ,View:boolean;
          Tab,MaxTab:integer;
          Scroller:byte;    {0 -  ⮡ࠦ; 1..3 - ⨫}
          XS,YS1,YS2,       {न ᯮ}
          ColorS:byte;      {梥}
          LineCurr,         {⥪饥 }
          LineMax:dword;  {⢮ ப}
     end;


function  Brow(p:TBR2;key:word):word;
{ ࠡ뢠   key  ⥪ Brow}
procedure BrowRefresh(p:TBR2);
{  Brow}
function  BrowCreate(q:pointer;X_,Y_,MinX_,MinY_,MaxX_,MaxY_,Tab_,Color_:byte;
                     b:boolean;Scroller_:byte):TBR2;
{ ᮧ Brow}
procedure BrowDelete(p:TBR2);
{ 㤠 Brow}

function  BrowNewRecord(s:string;Col:byte;q1:pointer;w:word;b:boolean;c1,c2:byte):pointer;
{     Brow
 (뤥 ,  ,    ॢ)
 s   - ப
 Col -  梥⮢ 
 q1  - ।騩  ॢ
 w   - ࠧ 
 b   -  TreeInsRecord
 頥 㪠⥫    ॢ
}

function BrowReplRecord(s:string;q1:Pointer;w:word;Col,c1,c2:byte):Pointer;
{      }

function  IncTab(p:TBR2):boolean;
{ 㢥稢 祭 ਧ⠫쭮 ᤢ}
function  DecTab(p:TBR2):boolean;
{ 㬥蠥 祭 ਧ⠫쭮 ᤢ}

implementation

Function IncTab(p:TBR2):Boolean;
Begin
     With p^ Do If Tab<MaxTab Then Begin
          IncTab:=True;
          Inc(Tab)
         End Else IncTab:=False;
End;

Function DecTab(p:TBR2):Boolean;
Begin
     With p^ Do If Tab>0 Then Begin
          DecTab:=True;
          Dec(Tab)
         End Else DecTab:=False;
End;

Function BrowCreate(q:Pointer;X_,Y_,MinX_,MinY_,MaxX_,MaxY_,Tab_,Color_:Byte;
                    b:Boolean;Scroller_:Byte):TBR2;
Var p:TBR2;
    p1:TBR1;
Begin
     p:=MemAlloc(SizeOf(p^));
     BrowCreate:=p;
     If p<>Nil Then With p^ Do Begin
        X:=X_; Y:=Y_; MinX:=MinX_; MinY:=MinY_; MaxX:=MaxX_; MaxY:=MaxY_;
        Tec:=q; Activ:=False; Refresh:=True; Tab:=Tab_; MaxTab:=0; View:=b;
        Color:=Color_; Scroller:=Scroller_; XS:=MaxX_+1;
        YS1:=MinY_; YS2:=MaxY_; ColorS:=Color_;
        p1:=q; LineMax:=0; LineCurr:=0;
        If p1<>Nil Then Begin
           While p1<>Nil Do Begin
                 If Byte(p1^.PName^[0])>MaxTab Then
                    MaxTab:=Byte(p1^.PName^[0]);
                 Inc(LineCurr); Inc(LineMax); p1:=p1^.Prev;
           End;
           p1:=q;
           While p1<>Nil Do Begin
                 If Byte(p1^.PName^[0])>MaxTab Then
                    MaxTab:=Byte(p1^.PName^[0]);
                 Inc(LineMax); p1:=p1^.Next;
           End;
           Dec(LineMax);
           MaxTab:=MaxTab-(MaxX-MinX)-1;
        End;
        If LineCurr>MaxY-MinY Then Y:=MaxY Else Y:=MinY+LineCurr;
     End;
End;

Procedure BrowDelete(p:TBR2);
Begin
     MemFree(p);
End;

Procedure BrowRefresh(p:TBR2);
Var q:TBR1;
    i,Col:Byte;
Begin
   If (p<>Nil) Then With p^ Do Begin
        q:=Tec;

     { Refresh brow begin }

        Refresh:=False;
        If Y<MinY Then Y:=MinY;
        If Y>MaxY Then Y:=MaxY;
        i:=Y-MinY;
        If q<>Nil Then While (q^.Prev<>Nil)And(i>0) Do Begin
              q:=q^.Prev;
              Dec(i);
        End;
        Y:=Y-i;
        ColorBackSet(ColorAr[Color,2]);
        ColorTextSet(ColorAr[Color,4]);
        ScrClr(MinX,MinY,MaxX,MaxY);
        i:=MinY;
        While (q<>Nil)And(i<=MaxY) Do {With q^ Do} Begin

           Col:=q^.Color1;
           ColorBackSet(Col shr 4);
           ColorTextSet(Col and $0F);

           OutStr(X,i,DopSpace(q^.PName^,MaxX-MinX+1,p^.Tab));
{-[Start]------------------------------------------------------[2001.05.20]--}
           ColorTextSet((not(Col shr 4))and $0F);
           If (p^.Tab>0)And(Byte(q^.PName^[0])>(MaxX-MinX+1)) Then
              OutStr(X,i,'<');
           If (Byte(q^.PName^[0])>(MaxX-MinX+1+p^.Tab)) Then
              OutStr(X+(MaxX-MinX),i,'>');
{-[End]--------------------------------------------------------[2001.05.20]--}
           Inc(i);
           q:=q^.Next;
        End;
        q:=p^.Tec;
        if q<>Nil then begin {03.03.10}
         If (Activ)And(Not View)And(q<>Nil) Then Begin
            Col:=q^.Color2;
            Col:=q^.Color2;
            ColorBackSet(Col shr 4);
            ColorTextSet(Col and $0F);
            Mark(X,Y,MaxX);
         End;
        end;
{-[Start]------------------------------------------------------[2001.05.20]--}
        If (Scroller>0)And(Scroller<=3) Then Begin
           {LineCurr:=0;
           While q<>Nil Do Begin
                 Inc(LineCurr); q:=q^.Prev;
           End;}
           ColorBackSet(ColorAr[ColorS,2]);
           ColorTextSet(ColorAr[ColorS,4]);
           LineV(YS1,XS,YS2,
                ScrollType[Scroller,1],
                ScrollType[Scroller,2],
                ScrollType[Scroller,3]);

           If LineMax>(MaxY-MinY+1) Then
              OutStr(XS,YS1+Trunc((YS2-YS1)*(LineCurr/LineMax)),ScrollType[Scroller,4]);
        End;
{-[End]--------------------------------------------------------[2001.05.20]--}
     { Refresh brow end }
       {
        CursSet(1,24);
        Write('Debug: LineCurr=',linecurr,' LineMax=',linemax,' ');GetKey;GetKey;
       }
   End;
End;

Function Brow(p:TBR2;key:Word):Word;
Var
    Flag:Boolean;
    q:TBR1;
    i:Byte;
Begin
//halt(1);
   If (p<>Nil) Then With p^ Do Begin
     If Refresh Then BrowRefresh(p);
     If key=kbNoKey Then Flag:=True Else Flag:=False;
     If p^.Activ Then Repeat
        If Flag Then If KeyPressed Then key:=GetKey_;
        If (p<>Nil)And(p^.Tec<>Nil) Then With p^ Do Begin
           q:=Tec;
           Case key of
           {Arrow Up}
                kbGrUp,
                kbUp:If q^.Prev<>Nil Then Begin
                      If View Then Begin
                        For i:=0 To Y-MinY Do if(q^.Prev<>Nil)Then begin
                           q:=q^.Prev;
                           Dec(LineCurr);
                        end;
                        Y:=MinY;
                      End Else Begin
                        q:=q^.Prev;
                        Dec(Y);
                        Dec(LineCurr);
                      End;
                      Refresh:=True;
                     End;
           {Arrow Down}
                kbGrDown,
                kbDown:If q^.Next<>Nil Then Begin
                        If View Then Begin
                          For i:=0 To MaxY-Y Do if(q^.Next<>Nil)Then begin
                           q:=q^.Next;
                           Inc(LineCurr);
                          end;
                          Y:=MaxY;
                        End Else Begin
                          q:=q^.Next;
                          Inc(Y);
                          Inc(LineCurr);
                        End;
                        Refresh:=True;
                     End;
           {Home}
                kbGrHome,
                kbHome:If q^.Prev<>Nil Then Begin
                        Y:=MinY;
                        While (q^.Prev<>Nil) Do q:=q^.Prev;
                        LineCurr:=1;
                        Refresh:=True;
                     End;
           {End}
                kbGrEnd,
                kbEnd:If q^.Next<>Nil Then Begin
                        Y:=MaxY;
                        While (q^.Next<>Nil) Do q:=q^.Next;
                        LineCurr:=LineMax;
                        Refresh:=True;
                     End;
           {PgUp}
                kbGrPgUp,
                kbPgUp:If q^.Prev<>Nil Then Begin
                          If View Then For i:=0 To Y-MinY Do
                             If(q^.Prev<>Nil)Then begin
                               q:=q^.Prev;
                               dec(LineCurr);
                             end;
                          Y:=MinY;
                          For i:=1 To MaxY-MinY Do
                           If(q^.Prev<>Nil)Then begin
                             q:=q^.Prev;
                             dec(LineCurr);
                           end;
                          Refresh:=True;
                     End;
           {PgDown}
                kbGrPgDn,
                kbPgDn:If q^.Next<>Nil Then Begin
                          If View Then For i:=0 To MaxY-Y Do
                             If(q^.Next<>Nil)Then begin
                               q:=q^.Next;
                               inc(LineCurr);
                             end;
                          Y:=MaxY;
                          For i:=1 To MaxY-MinY Do
                           If(q^.Next<>Nil)Then begin
                             q:=q^.Next;
                             inc(LineCurr);
                           end;
                          Refresh:=True;
                     End;
           End; {Case}
           Tec:=q;
        End;
     Until (key<>kbNoKey)Or(Not Flag);

     If Refresh Then BrowRefresh(p);
   End;
   Brow:=key;
End;

Function BrowNewRecord(s:String;Col:byte;q1:Pointer;w:word;b:Boolean;c1,c2:byte):Pointer;
Var q:TBR1;
Begin
     q:=MemAlloc({SizeOf(q^)}w+Byte(s[0]));
     If q<>Nil Then With q^ Do Begin
        Color:=Col;
        if Col=$0FF then begin
         Color1:=c1;
         Color2:=c2;
        end else if Col>ColorMax then begin
         Color1:=(ColorAr[2,2]shl 4)or(ColorAr[2,4]and $0F);
         Color2:=(ColorAr[2,1]shl 4)or(ColorAr[2,3]and $0F);
        end else begin
         Color1:=(ColorAr[Col,2]shl 4)or(ColorAr[Col,4]and $0F);
         Color2:=(ColorAr[Col,1]shl 4)or(ColorAr[Col,3]and $0F);
        end;
        dword(PName):=dword(@Name)+w-SizeOf(BrowRec1);
        {PName:=@Name;}
        PName^:=s;
//        MemCopy(@s[0],PName,byte(s[0])+1);
     End;
     TreeInsRecord(q1,q,b);
     BrowNewRecord:=q;
End;

Function BrowReplRecord(s:string;q1:Pointer;w:word;Col,c1,c2:byte):Pointer;
Var q:TBR1;
Begin
     if q1<>Nil then begin
       if TBR1(q1)^.PName^[0]>=s[0] then TBR1(q1)^.PName^:=s
       else begin
         q:=MemAlloc(w+Byte(s[0]));
         If q<>Nil Then Begin
           MemCopy(q1,q,w);
           MemFree(q1);
           q1:=q;
           With q^ Do Begin
            if Next<>Nil then TBR1(Next)^.Prev:=q;
            if Prev<>Nil then TBR1(Prev)^.Next:=q;
            dword(PName):=dword(@Name)+w-SizeOf(BrowRec1);
            PName^:=s;
           End;
         End;
       End;
       If q1<>Nil Then With TBR1(q1)^ Do Begin
          Color:=Col;
          if Col=$0FF then begin
           Color1:=c1;
           Color2:=c2;
          end else if Col>ColorMax then begin
           Color1:=(ColorAr[2,2]shl 4)or(ColorAr[2,4]and $0F);
           Color2:=(ColorAr[2,1]shl 4)or(ColorAr[2,3]and $0F);
          end else begin
           Color1:=(ColorAr[Col,2]shl 4)or(ColorAr[Col,4]and $0F);
           Color2:=(ColorAr[Col,1]shl 4)or(ColorAr[Col,3]and $0F);
          end;
          dword(PName):=dword(@Name)+w-SizeOf(BrowRec1);
          PName^:=s;
       End;
     End;
     BrowReplRecord:=q1;
End;

End.
