unit regimp;
interface
uses plType;

type PRegImp = ^TRegImp;
     TRegImp = record
      t:text;
      CurrKey,
      ValidKey,
      sKey,
      sSubKey:string;
      L:dword;
      oper,
      ignore,
      keypresent:boolean;
    //-----------------
      param:string;
      svalue:string;
      dvalue:dword;
      hvalue:AByte;
      hsize:word;
      ptype:dword;
     end;

function  RegImpOpen(fn,vKey:string):PRegImp;
procedure RegImpClose(var p:PRegImp);
function  RegImpNext(p:PRegImp;b:boolean):boolean;
implementation
uses plStr,plMem;
const
      ExpSpec:Array[0..1] of string[6] = (
      '\"'+#$0A+#$0B+#$0C+#$0D,'\"nvfr');

function str2hex(s:string;var hvalue:AByte;var hsize:word):string;
var i,j:integer;
begin
 s:=ltrim(s);
 result:=s;
 while(s<>'')and(hsize<64000)do begin
  val('$0'+copy(s,1,2),i,j);
  if j=0 then begin
   inc(hsize);
   hvalue[hsize]:=byte(i);
   s:=ltrim(copy(s,3,byte(s[0])-2));
   result:=s;
   if(s<>'')and(s[1]=',')then begin
    s:=ltrim(copy(s,2,byte(s[0])-1));
   end else break;
  end else break;
 end;
end;

procedure ParseKey(s:string;var sKey,sSubKey:string);
const keys: array [0..1,0..7] of string[35] =
      (('HKEY_USERS\{',
        'HKEY_CLASSES_ROOT',
        'HKEY_USERS\.DEFAULT',
        'HKEY_CURRENT_USER',
        'HKEY_LOCAL_MACHINE\SAM',
        'HKEY_LOCAL_MACHINE\SECURITY',
        'HKEY_LOCAL_MACHINE\SOFTWARE',
        'HKEY_LOCAL_MACHINE\SYSTEM'),

       ('HKEY_USERS\.DEFAULT',
        'HKEY_LOCAL_MACHINE\SOFTWARE',
        'HKEY_CURRENT_USER',
        'HKEY_CURRENT_USER',
        'HKEY_LOCAL_MACHINE\SAM',
        'HKEY_LOCAL_MACHINE\SECURITY',
        'HKEY_LOCAL_MACHINE\SOFTWARE',
        'HKEY_LOCAL_MACHINE\SYSTEM'));
var i:integer;
begin
 sKey:='';
 sSubKey:='';
 if pos(keys[0,0],upcase(s))=1 then begin
  i:=pos('\',s);
  if pos('}',copy(s,length(keys[0,0])+1,length(s)-length(keys[0,0])))=i-1 then begin
   sKey:=keys[1,0];
   sSubKey:=copy(s,i+1,length(s)-i);
  end;
 end else begin
  i:=1;
  while i<=7 do begin
   if pos(keys[0,i],upcase(s))=1 then begin
    sKey:=keys[1,i];
    sSubKey:=copy(s,length(keys[0,i])+2,length(s)-length(keys[0,i])-1);
    if i=1 then begin
     if sSubKey='' then sSubKey:='Classes'
     else sSubKey:='Classes\'+sSubKey;
    end;
    break;
   end else inc(i);
  end;
 end;
end;

function RegImpOpen(fn,vKey:string):PRegImp;
{      fn -  䠩  
 ValidKey - ਢ離 䠫 ॥  ⪥
}
var s:string;
begin
 result:=MemAlloc(SizeOf(TRegImp));
 if result<>nil then with result^ do begin
  assign(t,fn);
  reset(t);
  L:=0;
  s:='';
  while not eof(t) do begin
   readln(t,s);inc(L);
   s:=ltrim(rtrim(s));
   if s<>'' then break;
  end;
  if s<>'REGEDIT4'then begin
   close(t);
   MemFree(result);
   // exit;
  end else begin
   CurrKey:='';
   ValidKey:=vKey;
   sKey:='';
   sSubKey:='';
   oper:=true;
   ignore:=false;
   keypresent:=false;
 //-----------------
   param:='';
   svalue:='';
   dvalue:=0;
   hsize:=0;
   ptype:=0;
  end;
 end;
end;
procedure RegImpClose(var p:PRegImp);
begin
 if p<>nil then begin
  close(p^.t);
  MemFree(p);
 end;
end;
function RegImpNext(p:PRegImp;b:boolean):boolean;
{ b - true = ⢥  ᥬ ப;
      false = ⮫쪮  
}
var s:string;
    i,j:integer;
begin
 result:=false;
 if p<>nil then with p^ do begin
  while not eof(t) do begin
   readln(t,s);inc(L);
   s:=ltrim(rtrim(s));
   ignore:=true;
   if(s<>'')and(s[1]<>';')then begin
    if(byte(s[0])>1)and(s[1]='[')and(s[byte(s[0])]=']')then begin
     // ࠡ⪠ 
     CurrKey:='';
     param:='';
     keypresent:=false;
     oper:=true;
     s:=copy(s,2,byte(s[0])-2);
     if byte(s[0])>0 then begin
      if(s[1]='-')then begin
       oper:=false;
       s:=copy(s,2,byte(s[0])-1);
      end else oper:=true;
      ParseKey(s,sKey,sSubKey);
      if upcase(sKey)=upcase(ValidKey) then begin
       ignore:=false;
       if oper then begin
        keypresent:=true;
        CurrKey:=sSubKey;
       end;
       {if oper then writeln(out,L,' Add key') else writeln(out,L,' Del key');}
      end;
     end;
    end else if keypresent then begin
     // ࠡ⪠ ࠬ஢
     param:='';
     svalue:='';
     dvalue:=0;
     hsize:=0;
     ptype:=0;
     oper:=true;
     if s[1]='@' then begin
      s:=ltrim(copy(s,2,byte(s[0])-1));
      param:='@';
     end else if s[1]='"' then begin
      i:=2;
      while i<=byte(s[0])do begin
       if s[i]='"'then break
       else if(s[i]='\')and(i<byte(s[0]))then begin
        j:=pos(s[i+1],ExpSpec[1]);
        if j>0 then begin
         inc(i);
         param:=param+ExpSpec[j];
        end else param:=param+s[i];
       end else param:=param+s[i];
       inc(i);
      end;
      if(param<>'')and(i<byte(s[0]))then
       s:=ltrim(copy(s,i+1,byte(s[0])-i));
     end;
     if(s<>'')and(s[1]='=')then begin
      s:=ltrim(copy(s,2,byte(s[0])-1));
      if(s<>'')then begin
       if(s[1]='-')then begin
        s:=ltrim(copy(s,2,byte(s[0])-1));
        if(s='')or(s[1]=';')then begin
         oper:=false;
         ignore:=false;
        end;
       end else if(s[1]='"')then begin
        ptype:=1;
        i:=2;
        while i<=byte(s[0])do begin
         if s[i]='"'then break
         else if(s[i]='\')and(i<byte(s[0]))then begin
          j:=pos(s[i+1],ExpSpec[1]);
          if j>0 then begin
           inc(i);
           svalue:=svalue+ExpSpec[j];
          end else svalue:=svalue+s[i];
         end else svalue:=svalue+s[i];
         inc(i);
        end;
        s:=ltrim(copy(s,i+1,byte(s[0])-i));
        if(s<>'')and(s[1]<>';')then begin
         param:='';
         svalue:='';
         ptype:=0;
        end else ignore:=false;
       end else if(pos('DWORD:',upcase(s))=1)then begin
        ptype:=4;
        s:=ltrim(copy(s,7,byte(s[0])-6));
        if(s<>'')then begin
         i:=pos(' ',s+' ');
         j:=pos(';',s+';');
         if j<i then i:=j;
         val('$0'+copy(s,1,i-1),dvalue,j);
         if j=0 then begin
          s:=ltrim(copy(s,i+1,byte(s[0])-i));
          if(s<>'')and(s[1]<>';')then begin
           param:='';
           dvalue:=0;
           ptype:=0;
          end else ignore:=false;
         end;
        end;
       end else if(pos('HEX',upcase(s))=1)then begin
        s:=copy(s,4,byte(s[0])-3);
        if(s<>'')and(s[1]='(')then begin
         i:=pos(')',s);
         if(i>1)and(i<10)then begin
          val('$0'+copy(s,2,i-2),ptype,j);
          if j=0 then s:=copy(s,i+1,byte(s[0])-i);
         end;
        end else ptype:=3;
        if(s<>'')and(s[1]=':')then begin
         s:=ltrim(copy(s,2,byte(s[0])));
         // ᨬ ப   १ 
         repeat
          if(s<>'')and(s[1]='\')then begin
           while not eof(t) do begin
            readln(t,s);inc(L);
            s:=ltrim(s);
            if(s<>'')and(s[1]<>';')then break;
           end;
          end;
          if(s<>'')and(s[1]='\')then break;
          if(s<>'')and(s[1]<>';')then s:=str2hex(s,hvalue,hsize);
          if(s='')or(s[1]=';')then begin
           ignore:=false;
           break;
          end;
          if(s<>'')and(s[1]=',')then begin
           s:=ltrim(copy(s,2,byte(s[0])-1));
           if(s='')or(s[1]<>'\')then break;
          end;
         until eof(t);
        end;
       end;
      end;
     end;
     {if not ignore then begin
      if not oper then begin
       writeln(out,L,' Del param');
      end else begin
       writeln(out,L,' Add param');
      end;
     end;}
    end;
    if(b)or((not(b))and(not(ignore)))then begin
     result:=true;
     break;
    end;
   end;
  end; {while not eof(t)}
 end;
end;
end.
